//parts of this program are based on Chromium OS source

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <linux/input.h>

#define BITS_PER_LONG (sizeof(long) * 8)
#define NBITS(x)      ((((x)-1)/BITS_PER_LONG)+1)
#define OFF(x)        ((x)%BITS_PER_LONG)
#define LONG(x)       ((x)/BITS_PER_LONG)
#define IS_BIT_SET(bit,array) ((array[LONG(bit)] >> OFF(bit)) & 1)

int main(int argc, char *argv[])
{
  char name[100];
  int i, fd;
  unsigned long sw[NBITS(SW_LID + 1)];
  int state = 0; //0 = lid open, 1 = lid closed
  int found = 0;

  for (i = 0; 1; i++) {
    sprintf(name, "/dev/input/event%i", i);
    fd = open(name, O_RDONLY);
    if (fd < 0) break;
    ioctl(fd, EVIOCGNAME(sizeof(name)), name);
    if (strcmp(name, "gpio-keys") == 0) {
      memset(sw, 0, sizeof(sw));
      if (ioctl(fd, EVIOCGSW(sizeof(sw)), sw) == 0)
        state = IS_BIT_SET(SW_LID, sw);
      found = 1;
    }
    close(fd);
    if (found) break;
  }

  printf("%u\n", state);

  return 0;
}